/* C routine to filter out sensitive information in a staff file. */

// output goes to stdout

#include <stdio.h>

#define FNAME_PREFIX_LEN 18

main( int argc, char** argv )
{
  FILE *in;
  FILE *out = stdout;
  if (argc<=1) {
     fprintf(stderr,"sfilter needs a parameter (file name)\n");
     exit(1);
  }
  in = fopen( argv[1], "r" );
  if (!in) {
     fprintf(stderr,"sfilter cannot open file %s", argv[1]);
     exit(1);
  }
  while (!feof( in ))
  {
     // filter out fdelser-information:
     int c = fgetc( in );
     // fprintf(stderr,"filter reads %c = %d\n", c, (int) c );
     if (c=='f') {
        int c2 = fgetc( in );
       //  fprintf(stderr,"filter reads %c = %d\n", c2, (int) c2 );
        if (c2==246) {
           int c3 = fgetc( in );
         //   fprintf(stderr,"filter reads %c = %d\n", c3, (int) c3 );
           if (c3=='d') {
             int c4 = fgetc( in );
           //   fprintf(stderr,"filter reads %c = %d\n", c4, (int) c4 );
             if (c4=='d') {
                int c5;
             //    fprintf(stderr,"filter found fdd\n");
                c5 = fgetc(in);  // kill blank + 4 characters in year
                if (c5 != '?') c5 = fgetc(in);
                if (c5 != '?') c5 = fgetc(in);
                if (c5 != '?') c5 = fgetc(in);
                if (c5 != '?') c5 = fgetc(in);
             }
             else {
                fputc( c, out );
                fputc( c2, out );
                fputc( c3, out );
                fputc( c4, out );
             }
          }
          else {
             fputc( c , out );
             fputc( c2, out );
             fputc( c3, out );
          }
       }
       else {
          fputc( c , out );
          fputc( c2, out );
       }
     }
     else
       if (!feof(in)) 
         fputc( c, out );
  }
  exit(0);
}

