/* C routine to sum up integer numbers prefixed by $ in a file. */

#include <stdio.h>
#include <string.h>

#define FNAME_PREFIX_LEN 23

main( int argc, char** argv )
{
  FILE *in;
  FILE *out;
  int Psum = 0;  // total work cost per year
  if (argc<=1) {
     fprintf(stderr,"sumupP needs a parameter (file name)\n");
     exit(1);
  }
  /*fprintf(stderr,"sumup %s", argv[1]);*/
  in = fopen( argv[1], "r" );
  if (!in) {
     fprintf(stderr,"sumupP cannot open file %s", argv[1]);
     exit(1);
  }
  while (!feof( in ))
  {
     int c = fgetc( in );
     if (c=='$') {
        int k=0;
        int c2 = fgetc( in );
        if (c2!='v' && c2!='h' && c2!='a' && c2!='y' 
            && c2!='p' && c2!='o' && c2!='T' && c2!='F' && c2!='P'
            && c2!='V' && c2!='H') {
           fprintf(stderr, 
                   "sumup ERROR in %s: character v, h, a, p, y, V, H, T, F expected after $, found %c\n", argv[1], c2);
           exit(1);
        }
        if (c2!='o') {
         fscanf(in, "%d", &k);
         switch (c2) {
           case 'P': Psum += k; break;
           default: break;
         }
        }
     }
  }
  fprintf(stdout, "Total work cost / arbetskostnader:  %d kr  (add 3%%, subtr 2xEXPORT)\n", Psum );
  exit(0);
}

